<script setup lang="ts">
    import logoSilab from '@/assets/logo.svg'
    import { useRoute } from 'vue-router'
    import { serviceOfferInjectionKey } from '@/shared/constants'
    import { inject } from 'vue'
    import { isDefined } from '@/shared/helpers/types'

    interface Props {
        pageTitle?: string
        showTitle?: boolean
        pageIsLoading?: boolean
    }
    withDefaults(defineProps<Props>(), {
        showTitle: true,
        pageIsLoading: false,
        pageTitle: '',
    })

    const route = useRoute()
    const serviceOffer = inject(serviceOfferInjectionKey, undefined)
</script>
<template>
    <v-app-bar class="d-print-none">
        <v-progress-linear
            v-if="pageIsLoading"
            indeterminate
            color="primary"
            data-cy="loader"
            style="position: absolute; top: 0; width: 100vw; z-index: 10000"
        ></v-progress-linear>
        <v-btn
            v-if="
                isDefined(serviceOffer) &&
                serviceOffer.getItemRoute().name !== route.name
            "
            color="on-background"
            :to="serviceOffer.getItemRoute()"
            data-cy="go-to-ods"
        >
            <div style="display: flex; flex-direction: column">
                <v-icon :icon="serviceOffer.getRootPageIcon()"></v-icon>
                <v-icon
                    icon="mdi-keyboard-return"
                    style="margin: -5px 0"
                ></v-icon>
            </div>
            <span v-if="$vuetify.display.mdAndUp" class="ml-3">{{
                serviceOffer.title
            }}</span>
        </v-btn>
        <router-link
            v-else
            to="/"
            class="text-decoration-none d-flex align-center pl-2"
            data-cy="go-to-home-button"
        >
            <v-img
                :src="logoSilab"
                alt="Logo Silab"
                height="50"
                width="50"
            ></v-img>
            <span
                class="text-h5 d-none d-sm-inline text-grey-darken-2"
                data-cy="app-name"
            >
                Siilab
            </span>
        </router-link>
        <v-fade-transition hide-on-leave>
            <v-app-bar-title
                v-show="showTitle"
                class="text-center mx-auto contextual-navbar-title"
            >
                <div
                    class="text-wrap"
                    :class="$vuetify.display.xs ? 'text-subtitle-1' : undefined"
                >
                    {{ pageTitle }}
                </div>
            </v-app-bar-title>
        </v-fade-transition>
        <slot name="contextualButtons"></slot>
    </v-app-bar>
</template>
<style scoped lang="scss">
    .v-toolbar-title.contextual-navbar-title {
        flex: 3 1 auto;
    }
</style>
